Index: /trunk/src/lib/network/proxy/network_settings.h
===================================================================
--- /trunk/src/lib/network/proxy/network_settings.h	(revision 9493)
+++ /trunk/src/lib/network/proxy/network_settings.h	(revision 9494)
@@ -37,13 +37,16 @@
     inline void setMaxPlayer(int number) { this->maxPlayer = number; }
     /** @returns teh max number of players */
-    int getMaxPlayer() { return this->maxPlayer; }
+    int getMaxPlayer() const { return this->maxPlayer; }
+    /** sets the @param saturation: a threshold in percente when the proxy servers should be activated to be able to redirect the clients */
+    inline void setMaxPlayerSaturation(float saturation) { this->maxPlayerSaturation = saturation; }
+
 
     void setMasterAddr(const std::string& masterAddr);
     /** @returns the address of the master server read from the network config file */
-    inline IP getMasterAddr() { return this->masterServer; }
+    inline const IP& getMasterAddr() const { return this->masterServer; }
 
     void setProxyAddr(const std::string& proxyAddr);
     /** @returns the list of proxy servers from the init file */
-    inline std::vector<IPaddress*>* getProxyList() { return &this->proxies; }
+    inline std::vector<IP>* getProxyList() { return &this->proxies; }
 
 
@@ -53,7 +56,10 @@
 
   private:
-    static NetworkSettings*        singletonRef;            //!< Pointer to the only instance of this Class
+    static NetworkSettings*      singletonRef;            //!< Pointer to the only instance of this Class
+
     int                          maxPlayer;               //!< maximal number of players
-    std::vector<IPaddress*>      proxies;                 //!< all registered proxies
+    float                        maxPlayerSaturation;     //!< the saturation level from where on the proxy server should be activated
+
+    std::vector<IP>              proxies;                 //!< all registered proxies
     IP                           masterServer;            //!< master server ip address
 
Index: /trunk/src/lib/network/shared_network_data.cc
===================================================================
--- /trunk/src/lib/network/shared_network_data.cc	(revision 9493)
+++ /trunk/src/lib/network/shared_network_data.cc	(revision 9494)
@@ -20,4 +20,6 @@
 #include "state.h"
 
+#include "network_stream.h"
+
 #include "debug.h"
 
@@ -34,5 +36,5 @@
   this->setClassID(CL_SHARED_NETWORK_DATA, "SharedNetworkData");
 
-  this->nodeType = NET_CLIENT;
+  this->nodeType = NET_MASTER_SERVER;
   this->hostID = -1;
   this->defaultSyncStream = NULL;
@@ -51,2 +53,31 @@
   SharedNetworkData::singletonRef = NULL;
 }
+
+
+
+/** @return true if this user is connected to the local host */
+bool SharedNetworkData::isUserLocal( int userID)
+{
+  return this->defaultSyncStream->isUserLocal(userID);
+}
+
+
+/** @returns true if this user is a master server */
+bool SharedNetworkData::isUserMasterServer( int userID )
+{
+  return this->defaultSyncStream->isUserMasterServer(userID);
+}
+
+
+/** @returns true if this user is a proxy server */
+bool SharedNetworkData::isUserProxyServerActive( int userID )
+{
+   return this->defaultSyncStream->isUserProxyServerActive(userID);
+}
+
+
+/** @returns true if this user is a client */
+bool SharedNetworkData::isUserClient( int userID )
+{
+  return this->defaultSyncStream->isUserClient(userID);
+}
Index: /trunk/src/lib/network/shared_network_data.h
===================================================================
--- /trunk/src/lib/network/shared_network_data.h	(revision 9493)
+++ /trunk/src/lib/network/shared_network_data.h	(revision 9494)
@@ -14,5 +14,5 @@
 #define NET_MAX_CONNECTIONS 2
 
-class NetworkStream;
+
 class Synchronizeable;
 
@@ -28,16 +28,26 @@
 
     /** @returns the next uniqueID free for an object */
-    inline int getNewUniqueID() { return ( this->nodeType != NET_CLIENT)?this->newUniqueID++:-1; }
+    inline int getNewUniqueID() { return ( isMasterServer())?this->newUniqueID++:-1; }
     /** sets the @param newUniqueID: the new offset for the next unique id */
     inline void setNewUniqueID(int newUniqueID) { this->newUniqueID = newUniqueID; }
 
+    /** sets the game server flag @param bGameServer true if it is a game server */
+    inline void setNodeType(int nodeType) { this->nodeType = nodeType; }
     /** @returns true is this node is a master server */
     inline bool isMasterServer() { return this->nodeType == NET_MASTER_SERVER; }
     /** @returns true is this node is a proxy server */
-    inline bool isProxyServer() { return this->nodeType == NET_PROXY_SERVER_ACTIVE; }
+    inline bool isProxyServerActive() { return this->nodeType == NET_PROXY_SERVER_ACTIVE; }
     /** @returns true is this node is a client*/
     inline bool isClient() { return this->nodeType == NET_CLIENT; }
-    /** sets the game server flag @param bGameServer true if it is a game server */
-    inline void setNodeType(int nodeType) { this->nodeType = nodeType; }
+
+    /** @return true if this user is connected to the local host */
+    bool isUserLocal( int userID);
+    /** @returns true if this user is a master server */
+    bool isUserMasterServer( int userID );
+    /** @returns true if this user is a proxy server */
+    bool isUserProxyServerActive( int userID );
+    /** @returns true if this user is a client */
+    bool isUserClient( int userID );
+
 
     /** @returns the maximum number of players for this server */
Index: /trunk/src/lib/network/synchronizeable.cc
===================================================================
--- /trunk/src/lib/network/synchronizeable.cc	(revision 9493)
+++ /trunk/src/lib/network/synchronizeable.cc	(revision 9494)
@@ -72,5 +72,6 @@
     this->networkStream->disconnectSynchronizeable(*this);
 
-    if ( (SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer() )
+    // remove the message manager only by the server
+    if ( (SharedNetworkData::getInstance()->isMasterServer() )
            && this->beSynchronized() && this->getUniqueID() > 0 && !this->isA( CL_MESSAGE_MANAGER ) )
       NetworkGameManager::getInstance()->removeSynchronizeable( this->getUniqueID() );
@@ -213,5 +214,5 @@
       hasPermission = true;
     // now check PROXY_SERVER permissions
-    else if( SharedNetworkData::getInstance()->isProxyServer() && (*it)->checkPermission( PERMISSION_MASTER_SERVER ))
+    else if( SharedNetworkData::getInstance()->isProxyServerActive() && (*it)->checkPermission( PERMISSION_PROXY_SERVER ))
       hasPermission = true;
     // now check OWNER permissions
@@ -222,8 +223,10 @@
       hasPermission = true;
     // SPECIAL: get write permissions if i am master server and i am able to overwrite the client stuff
+#warning this could probably override also clients that are connected to another proxy: the master server overwrites it
     else if( SharedNetworkData::getInstance()->isMasterServer() && this->owner != userId && (*it)->checkPermission( PERMISSION_OWNER ))
       hasPermission = true;
     // SPECIAL: get write permissions if i am proxy server and i am able to overwrite the client stuff
-    else if( SharedNetworkData::getInstance()->isProxyServer()  && this->owner != userId && (*it)->checkPermission( PERMISSION_OWNER ))
+    else if( SharedNetworkData::getInstance()->isProxyServerActive() && this->networkStream->isUserClient(userId)
+             && this->owner != userId && (*it)->checkPermission( PERMISSION_OWNER ) )
       hasPermission = true;
     else
@@ -354,5 +357,6 @@
       hasPermission = true;
     // now check PROXY_SERVER permissions
-    else if( this->networkStream->isUserProxyServer( userId )  && (*it)->checkPermission( PERMISSION_MASTER_SERVER ))
+    else if( this->networkStream->isUserProxyServerActive( userId )  && (*it)->checkPermission( PERMISSION_MASTER_SERVER )
+             && SharedNetworkData::getInstance()->isClient())
       hasPermission = true;
     // now check OWNER permissions
@@ -366,5 +370,6 @@
       hasPermission = true;
     // SPECIAL: get write permissions if im sending to a proxy server that does not own this sync
-    else if( this->networkStream->isUserProxyServer( userId )  && this->owner != SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ))
+    else if( this->networkStream->isUserProxyServerActive( userId ) && SharedNetworkData::getInstance()->isClient()
+              && this->owner != SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ))
       hasPermission = true;
     else
@@ -388,5 +393,5 @@
     else
     {
-//      PRINTF(0)("DONT SET VAR BECAUSE OF PERMISSION: %s %d %d %d %d %d %d\n", (*it)->getName().c_str(), (*it)->checkPermission( PERMISSION_MASTER_SERVER ), (*it)->checkPermission( PERMISSION_OWNER ), (*it)->checkPermission( PERMISSION_ALL ), networkStream->isUserServer( userId ), this->owner, userId );
+//       PRINTF(0)("DONT SET VAR BECAUSE OF PERMISSION: %s perm: %d %d %d - %d %d %d\n", (*it)->getName().c_str(), (*it)->checkPermission( PERMISSION_MASTER_SERVER ), (*it)->checkPermission( PERMISSION_OWNER ), (*it)->checkPermission( PERMISSION_ALL ), networkStream->isUserMasterServer( userId ), this->owner, userId );
       n = (*it)->getSizeFromBuf( stateTo->data + i, stateTo->dataLength - i );
       //NETPRINTF(0)("%s::setvar %s %d\n", getClassCName(), (*it)->getName().c_str(), n);
@@ -416,5 +421,4 @@
 void Synchronizeable::registerVar( SynchronizeableVar * var )
 {
-  //PRINTF(0)("ADDING VAR: %s\n", var->getName().c_str());
   syncVarList.push_back( var );
 }
@@ -428,5 +432,4 @@
 int Synchronizeable::registerVarId( SynchronizeableVar * var )
 {
-  //PRINTF(0)("ADDING VAR: %s\n", var->getName().c_str());
   syncVarList.push_back( var );
   var->setWatched( true );
Index: /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h
===================================================================
--- /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 9493)
+++ /trunk/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 9494)
@@ -10,10 +10,5 @@
 #include <string>
 
-enum {
-  PERMISSION_MASTER_SERVER = 1,
-  PERMISSION_PROXY_SERVER  = 2,
-  PERMISSION_OWNER         = 4,
-  PERMISSION_ALL           = 8
-};
+
 
 class SynchronizeableVar {
Index: /trunk/src/lib/network/udp_server_socket.cc
===================================================================
--- /trunk/src/lib/network/udp_server_socket.cc	(revision 9493)
+++ /trunk/src/lib/network/udp_server_socket.cc	(revision 9494)
@@ -94,4 +94,5 @@
 }
 
+
 /**
  * stop listening on server
@@ -220,5 +221,5 @@
   if ( !socket )
     return false;
-  
+
   assert( networkPacket.length <= UDP_PACKET_SIZE );
 
@@ -232,5 +233,5 @@
     return false;
   }
-  
+
   return true;
 }
@@ -244,4 +245,5 @@
   int newConn = 0;
 
+  // iterate through all newly received packets and assign them to the users packet buffer
   for ( res = SDLNet_UDP_Recv( socket, packet ); res == 1; res = SDLNet_UDP_Recv( socket, packet ) )
   {
@@ -250,10 +252,16 @@
 
     if ( packet->len <= 0 )
-      continue; 
-        
-    for ( userId =0; userId < (int)userList.size(); userId++ )
-      if ( userList[userId].addr.host == packet->address.host && userList[userId].addr.port == packet->address.port && userList[userId].randomByte == ( packet->data[0] & 0xFC ) )
+      continue;
+
+    // search the user id this backet belongs to
+    for ( userId = 0; userId < (int)userList.size(); userId++ )
+    {
+      if ( userList[userId].addr.host == packet->address.host &&
+           userList[userId].addr.port == packet->address.port &&
+           userList[userId].randomByte == ( packet->data[0] & 0xFC ) )
         break;
-
+    }
+
+    // is it a new packet initializing a new connecion?
     if ( userId >= (int)userList.size() )
     {
@@ -271,5 +279,5 @@
           break;
 
-      initUser( userId, packet->address, packet->data[0] & 0xFC );
+      this->initUser( userId, packet->address, packet->data[0] & 0xFC );
       UdpSocket * sock = new UdpSocket( this, packet->address, userId, packet->data[0] & 0xFC );
       newSocketList.push_back( sock );
@@ -277,6 +285,6 @@
     }
 
-    //add new packet to packetbuffer
-
+
+    // add new packet to packetbuffer
     NetworkPacket networkPacket;
     networkPacket.length = packet->len;
Index: /trunk/src/lib/network/udp_server_socket.h
===================================================================
--- /trunk/src/lib/network/udp_server_socket.h	(revision 9493)
+++ /trunk/src/lib/network/udp_server_socket.h	(revision 9494)
@@ -33,9 +33,12 @@
 typedef std::vector<NetworkPacketList> PacketBuffer;
 
+
+//!< informations struct for each user
 struct UserInfo
 {
-  IPaddress addr;
-  byte randomByte;
+  IPaddress     addr;            //!< ip address of this user
+  byte          randomByte;      //!< random byte of this user
 };
+
 
 typedef std::vector<UserInfo> UserList;
@@ -43,4 +46,6 @@
 typedef std::list<UdpSocket*> UdpSocketList;
 
+
+//!< the upd server socket listening for incoming connections
 class UdpServerSocket : public ServerSocket
 {
@@ -49,25 +54,29 @@
     virtual ~UdpServerSocket();
 
+    /* server socket manipulations */
     virtual bool listen( unsigned int port );
-
     virtual NetworkSocket* getNewSocket( void );
-
     virtual void close();
 
     virtual void update();
 
+    /* network traffic interface */
+    NetworkPacket getPacket( int userId );
+    void removeUser( int userId );
+    bool sendPacket( NetworkPacket networkPacket, int userId );
+
+
+  private:
     void removeUserPackets( int userId );
-    void removeUser( int userId );
-    NetworkPacket getPacket( int userId );
-    bool sendPacket( NetworkPacket networkPacket, int userId );
     int getPacketCount( int childId );
     void initUser( int childId, IPaddress ip, byte randomByte );
 
+
   private:
-    UDPsocket     socket;           //!< will be uses to send/recieve data
-    UDPpacket *   packet;           //!< packet structure to recieve packet
-    PacketBuffer  packetBuffer;     //!< will store recieved packets for UdpSockets
-    UserList      userList;         //!< contains information about clients
-    UdpSocketList newSocketList;    //!< contains new socket
+    UDPsocket          socket;           //!< will be used to send/recieve data to/from clients
+    UDPpacket *        packet;           //!< packet structure to recieve packet
+    PacketBuffer       packetBuffer;     //!< will store recieved packets for UdpSockets
+    UserList           userList;         //!< contains information about clients
+    UdpSocketList      newSocketList;    //!< contains new socket
 
 };
Index: /trunk/src/lib/network/zip.h
===================================================================
--- /trunk/src/lib/network/zip.h	(revision 9493)
+++ /trunk/src/lib/network/zip.h	(revision 9494)
@@ -21,5 +21,5 @@
 
 //! A class for compressing/uncompressing packes.
-class Zip 
+class Zip
 {
   public:
@@ -27,9 +27,9 @@
     /** @returns a Pointer to the only object of this Class */
     inline static Zip* getInstance(void) { if (!singletonRef) singletonRef = new Zip();  return singletonRef; };
-    
+
     int loadDictionary( std::string name );
     int zip( byte * from, int fromLength, byte * to, int maxLength, int dict = 0 );
     int unZip( byte * from, int fromLength, byte * to, int maxLength );
-    
+
     int getDictCount(){ return dicts.size(); }
 
@@ -37,7 +37,7 @@
     Zip();
     static Zip* singletonRef;
-    
+
     std::vector<DictionaryEntry> dicts;
 };
 
-#endif /* _PROTO_SINGLETON_H */
+#endif /* _ZIP_H */
Index: /trunk/src/story_entities/game_world.cc
===================================================================
--- /trunk/src/story_entities/game_world.cc	(revision 9493)
+++ /trunk/src/story_entities/game_world.cc	(revision 9494)
@@ -414,4 +414,11 @@
     double currentFrame = Timer::getNow();
 
+    if (currentFrame - this->lastFrame < .01)
+    {
+      SDL_Delay(1000.0 * (0.01 - (currentFrame - lastFrame)));
+      currentFrame = Timer::getNow();
+    }
+
+
     frameTimesIndex = this->cycle % TICK_SMOOTH_VALUE;
     this->frameTimes[frameTimesIndex] = currentFrame - this->lastFrame;
@@ -469,10 +476,10 @@
       this->dataTank->objectManager->getObjectList(OM_GROUP_00_PROJ));
   CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-    this->dataTank->objectManager->getObjectList(OM_GROUP_00));
+      this->dataTank->objectManager->getObjectList(OM_GROUP_00));
 
   CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-  this->dataTank->objectManager->getObjectList(OM_GROUP_02));
+      this->dataTank->objectManager->getObjectList(OM_GROUP_02));
   CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_02),
-  this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
+      this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
 
 
@@ -513,11 +520,11 @@
 {
 
-    // if this server is a dedicated server the game workd does not need to be drawn
+  // if this server is a dedicated server the game workd does not need to be drawn
   if( !GraphicsEngine::getInstance()->isDedicated())
   {
-  // render the reflection texture
-  this->renderPassReflection();
-  // redner the refraction texture
-  this->renderPassRefraction();
+    // render the reflection texture
+    this->renderPassReflection();
+    // redner the refraction texture
+    this->renderPassRefraction();
   }
   // render all
Index: /trunk/src/story_entities/multi_player_world_data.cc
===================================================================
--- /trunk/src/story_entities/multi_player_world_data.cc	(revision 9493)
+++ /trunk/src/story_entities/multi_player_world_data.cc	(revision 9494)
@@ -112,5 +112,5 @@
   const TiXmlElement* element = NULL;
 
-  if( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
+  if( SharedNetworkData::getInstance()->isMasterServer() /*|| SharedNetworkData::getInstance()->isProxyServerActive()*/)
   {
     /* load the spawning points */
@@ -148,5 +148,5 @@
     element = element->FirstChildElement();
 
-    if( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
+    if( SharedNetworkData::getInstance()->isMasterServer() /*|| SharedNetworkData::getInstance()->isProxyServerActive()*/)
     {
       while( element != NULL)
@@ -206,5 +206,5 @@
 
 
-    if( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
+    if( SharedNetworkData::getInstance()->isMasterServer() /*|| SharedNetworkData::getInstance()->isProxyServerActive()*/)
     {
       this->localPlayer = new Player();
@@ -284,5 +284,5 @@
 
   // create server playable
-  if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
+  if ( SharedNetworkData::getInstance()->isMasterServer() /*|| SharedNetworkData::getInstance()->isProxyServerActive()*/)
   {
     NetworkGameManager::getInstance()->signalNewPlayer( 0 );
Index: /trunk/src/subprojects/network/network_unit_test.cc
===================================================================
--- /trunk/src/subprojects/network/network_unit_test.cc	(revision 9493)
+++ /trunk/src/subprojects/network/network_unit_test.cc	(revision 9494)
@@ -276,5 +276,5 @@
   for(;;)
   {
-    MessageManager::getInstance()->sendMessage( TESTMESSAGEID, (byte*)"server to client", 18, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
+    MessageManager::getInstance()->sendMessage( TESTMESSAGEID, (byte*)"server to client", 18, RT_ALL_BUT_ME, 0, MP_HIGHBANDWIDTH );
     netMan->synchronize( 100 );
     SDL_Delay(100);
@@ -323,5 +323,5 @@
   {
     netMan->synchronize( 100 );
-    MessageManager::getInstance()->sendMessage( TESTMESSAGEID, (byte*)"client to server", 18, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
+    MessageManager::getInstance()->sendMessage( TESTMESSAGEID, (byte*)"client to server", 18, RT_ALL_BUT_ME, 0, MP_HIGHBANDWIDTH );
     ss = dynamic_cast<SimpleSync*>(ClassList::getObject( "Server", CL_SIMPLE_SYNC ) );
     SDL_Delay(100);
Index: /trunk/src/util/Makefile.am
===================================================================
--- /trunk/src/util/Makefile.am	(revision 9493)
+++ /trunk/src/util/Makefile.am	(revision 9494)
@@ -26,7 +26,5 @@
 			animation/animation_player.cc \
 			\
-			track/pilot_node.cc \
-			\
-			network_stats_widget.cc
+			track/pilot_node.cc
 
 #			track/track_manager.cc \
@@ -54,8 +52,5 @@
 			animation/t_animation.h \
 			\
-			track/pilot_node.h \
-			\
-			network_stats_widget.h
-
+			track/pilot_node.h
 
 #			track/track_manager.h \
Index: /trunk/src/util/game_rules.cc
===================================================================
--- /trunk/src/util/game_rules.cc	(revision 9493)
+++ /trunk/src/util/game_rules.cc	(revision 9494)
@@ -87,5 +87,5 @@
 void GameRules::registerKill(const Kill& kill)
 {
-  if ( SharedNetworkData::getInstance()->isClient() )
+  if ( SharedNetworkData::getInstance()->isClient() || SharedNetworkData::getInstance()->isProxyServerActive())
     return;
 
Index: /trunk/src/util/multiplayer_team_deathmatch.cc
===================================================================
--- /trunk/src/util/multiplayer_team_deathmatch.cc	(revision 9493)
+++ /trunk/src/util/multiplayer_team_deathmatch.cc	(revision 9494)
@@ -152,19 +152,29 @@
       box->setAbsCoor2D( 300, 100 );
 
-      OrxGui::GLGuiPushButton * buttonSpectator = new OrxGui::GLGuiPushButton("Spectator");
-      box->pack( buttonSpectator );
-      buttonSpectator->released.connect(this, &MultiplayerTeamDeathmatch::onButtonSpectator);
-
-      OrxGui::GLGuiPushButton * buttonRandom = new OrxGui::GLGuiPushButton("Random");
-      box->pack( buttonRandom );
-      buttonRandom->released.connect(this, &MultiplayerTeamDeathmatch::onButtonRandom);
-
-      OrxGui::GLGuiPushButton * buttonTeam0 = new OrxGui::GLGuiPushButton("Blue Team");
-      box->pack( buttonTeam0 );
-      buttonTeam0->released.connect(this, &MultiplayerTeamDeathmatch::onButtonTeam0);
-
-      OrxGui::GLGuiPushButton * buttonTeam1 = new OrxGui::GLGuiPushButton("Red Team");
-      box->pack( buttonTeam1 );
-      buttonTeam1->released.connect(this, &MultiplayerTeamDeathmatch::onButtonTeam1);
+      if( SharedNetworkData::getInstance()->isClient() ||  SharedNetworkData::getInstance()->isProxyServerActive())
+      {
+        OrxGui::GLGuiPushButton * buttonSpectator = new OrxGui::GLGuiPushButton("Spectator");
+        box->pack( buttonSpectator );
+        buttonSpectator->released.connect(this, &MultiplayerTeamDeathmatch::onButtonSpectator);
+
+        OrxGui::GLGuiPushButton * buttonRandom = new OrxGui::GLGuiPushButton("Random");
+        box->pack( buttonRandom );
+        buttonRandom->released.connect(this, &MultiplayerTeamDeathmatch::onButtonRandom);
+
+        OrxGui::GLGuiPushButton * buttonTeam0 = new OrxGui::GLGuiPushButton("Blue Team");
+        box->pack( buttonTeam0 );
+        buttonTeam0->released.connect(this, &MultiplayerTeamDeathmatch::onButtonTeam0);
+
+        OrxGui::GLGuiPushButton * buttonTeam1 = new OrxGui::GLGuiPushButton("Red Team");
+        box->pack( buttonTeam1 );
+        buttonTeam1->released.connect(this, &MultiplayerTeamDeathmatch::onButtonTeam1);
+      }
+      else
+      {
+        OrxGui::GLGuiText* text = new OrxGui::GLGuiText();
+        text->setText("Server Mode: not able to play at this node");
+        box->pack( text);
+      }
+
 
       if ( bShowTeamChange )
@@ -204,5 +214,5 @@
   assignPlayable();
 
-  if ( SharedNetworkData::getInstance()->isClient() )
+  if ( SharedNetworkData::getInstance()->isClient() || SharedNetworkData::getInstance()->isProxyServerActive())
     return;
 
@@ -268,5 +278,5 @@
 void MultiplayerTeamDeathmatch::checkGameRules()
 {
-  if ( SharedNetworkData::getInstance()->isClient() )
+  if ( SharedNetworkData::getInstance()->isClient() || SharedNetworkData::getInstance()->isProxyServerActive())
     return;
 
@@ -296,5 +306,5 @@
 
   if ( team == 0 || team == 1 )
-    return CL_FPS_PLAYER;
+    return CL_TURBINE_HOVER;
 
   assert( false );
@@ -303,4 +313,6 @@
 std::string MultiplayerTeamDeathmatch::getPlayableModelFileName( int userId, int team, ClassID classId )
 {
+  if (classId == CL_TURBINE_HOVER)
+   return "models/ships/hoverglider_mainbody.obj";
   if ( team == 0 )
     return "models/creatures/doom_guy.md2";
Index: /trunk/src/world_entities/creatures/fps_player.cc
===================================================================
--- /trunk/src/world_entities/creatures/fps_player.cc	(revision 9493)
+++ /trunk/src/world_entities/creatures/fps_player.cc	(revision 9494)
@@ -287,5 +287,5 @@
   //dealing damage
 
-  if ( State::isOnline() && (SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer()))
+  if ( State::isOnline() && (SharedNetworkData::getInstance()->isMasterServer() /*|| SharedNetworkData::getInstance()->isProxyServerActive()*/))
   {
     this->damageTicker -= time;
Index: /trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /trunk/src/world_entities/space_ships/space_ship.cc	(revision 9493)
+++ /trunk/src/world_entities/space_ships/space_ship.cc	(revision 9494)
@@ -310,14 +310,5 @@
 void SpaceShip::collidesWith(WorldEntity* entity, const Vector& location)
 {
-  Playable::collidesWith(entity, location);
-
-  if( entity->isA(CL_PROJECTILE) && entity != ref)
-  {
-    if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
-    {
-      //TODO handle this
-    }
-  }
-  PRINTF(3)("collision %s vs %s @ (%f,%f,%f)\n", this->getClassCName(), entity->getClassCName(), location.x, location.y, location.z);
+
 }
 
Index: /trunk/src/world_entities/space_ships/turbine_hover.cc
===================================================================
--- /trunk/src/world_entities/space_ships/turbine_hover.cc	(revision 9493)
+++ /trunk/src/world_entities/space_ships/turbine_hover.cc	(revision 9494)
@@ -126,5 +126,6 @@
   this->cameraNode.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
   //this->cameraNode.setParentMode(PNODE_ROTATE_MOVEMENT);
-  //this->cameraNode.setParent(this);
+  this->cameraNode.setParent(this);
+  this->cameraNode.setRelCoor(0,5,0);
 
   // rotors
@@ -211,5 +212,5 @@
   this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
   this->getWeaponManager().getFixedTarget()->setRelCoor(1000,0,0);
-  
+
   registerVar( new SynchronizeableBool( &bForward, &bForward, "bForward", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableBool( &bBackward, &bBackward, "bBackward", PERMISSION_OWNER ) );
@@ -218,5 +219,5 @@
   registerVar( new SynchronizeableBool( &bAscend, &bAscend, "bAscend", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableBool( &bDescend, &bDescend, "bDescend", PERMISSION_OWNER ) );
-  //registerVar( new SynchronizeableQuaternion( &direction, &direction, "direction", PERMISSION_OWNER ) );
+  registerVar( new SynchronizeableQuaternion( &direction, &direction, "direction", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableFloat( &cameraLook, &cameraLook, "cameraLook", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableFloat( &rotation, &rotation, "rotation", PERMISSION_OWNER ) );
@@ -294,11 +295,15 @@
 
   // spaceship controlled movement
+
+  // TRYING TO FIX PNode.
+  //this->cameraNode.setRelCoor(Vector(0.0f, 5.0f, 0.0f));//, 30.0f);
+  //this->cameraNode.setRelDir(Quaternion(this->smoothRotator  *10.0, Vector(0,1,0)));
+
   this->movement(dt);
   this->rotorCycle += this->rotorSpeed * dt;
-
-  // TRYING TO FIX PNode.
-  this->cameraNode.setAbsCoorSoft(this->getAbsCoor() + Vector(0.0f, 5.0f, 0.0f), 30.0f);
-  this->cameraNode.setRelDirSoft(this->getAbsDir(), 30.0f);
-}
+}
+
+
+#include "shared_network_data.h"
 
 /**
@@ -349,5 +354,6 @@
 
         this->velocity += (accelerationDir - damping)* dt;
-        this->shiftCoor (this->velocity * dt);
+        //if (this->getOwner() != SharedNetworkData::getInstance()->getHostID())
+          this->shiftCoor (this->velocity * dt);
 
         // limit the maximum rotation speed.
@@ -362,5 +368,6 @@
         }
 
-        this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
+        //if (this->getOwner() != SharedNetworkData::getInstance()->getHostID())
+          this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
 
         this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
@@ -407,24 +414,24 @@
 
     case Playable::Vertical:
-    {
-      accel.z = 0;
-      Vector accelerationDir = this->getAbsDir().apply(accel * this->acceleration);
-      accelerationDir.z=0;
+      {
+        accel.z = 0;
+        Vector accelerationDir = this->getAbsDir().apply(accel * this->acceleration);
+        accelerationDir.z=0;
 
         // this is the air friction (necessary for a smooth control)
-      Vector damping = (this->velocity * this->airFriction);
-
-      this->velocity += (accelerationDir - damping)* dt;
-      this->shiftCoor (this->velocity * dt);
-
-      this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
-
-      this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-      this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation + cameraLook, Vector(0,0,1)), 5);
-
-      this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
-      this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation + cameraLook, Vector(0,0,1)), 5);
-    }
-    break;
+        Vector damping = (this->velocity * this->airFriction);
+
+        this->velocity += (accelerationDir - damping)* dt;
+        this->shiftCoor (this->velocity * dt);
+
+        this->setRelDirSoft(this->direction * Quaternion(-cameraLook, Vector(0,0,1)), 5);
+
+        this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
+        this->rotorNodeLeft.setRelDirSoft(Quaternion(-accel.x * .07+this->rotation + cameraLook, Vector(0,0,1)), 5);
+
+        this->wingNodeRight.setRelDirSoft(Quaternion(accel.z * .05 +this->rotation, Vector(1,0,0)), 5);
+        this->rotorNodeRight.setRelDirSoft(Quaternion(-accel.x*.07 -this->rotation + cameraLook, Vector(0,0,1)), 5);
+      }
+      break;
     default:
       PRINTF(2)("Playmode %s Not Implemented\n", Playable::playmodeToString(this->getPlaymode()).c_str());
